// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   CurveManager.java

import java.io.*;
import java.util.Vector;

public class CurveManager
{

    Curve GetCurve(int i)
    {
        if(i < 0 || i > s_curves.size() - 1)
            return null;
        else
            return (Curve)s_curves.get(i);
    }

    void AddCurve(Curve curve)
    {
        for(int i = 0; i < s_curves.size(); i++)
            if(curve == s_curves.elementAt(i))
                return;

        s_curves.add(curve);
    }

    int GetCurvesCount()
    {
        return s_curves.size();
    }

    protected CurveManager()
    {
        DataInputStream s = null;
        try
        {
            s = new DataInputStream(new FileInputStream(s_curvefilename));
        }
        catch(FileNotFoundException e)
        {
            GameObject.CrashLog("Curve definition file " + s_curvefilename + " not found\n");
            return;
        }
        try
        {
            Curve c = null;
            for(; s.available() > 0; GameObject.LogLine("read curve definition: " + c.name + "[" + c.toString() + "]"))
            {
                byte b;
                switch(b = s.readByte())
                {
                case 1: // '\001'
                    c = new CurveSpline();
                    break;

                default:
                    GameObject.LogLine("[CurveManager] WARNING: Unknown curve type " + b);
                    break;
                }
                c.name = s.readUTF();
                c.samples = s.readUnsignedShort();
                c.minx = s.readFloat();
                c.maxx = s.readFloat();
                c.miny = s.readFloat();
                c.maxy = s.readFloat();
                if(c.minx > c.maxx || c.miny > c.maxy)
                {
                    GameObject.CrashLog("Error reading curve data: minx >= maxx");
                    return;
                }
                c.Read(s);
                s_curves.add(c);
                c.Build(c.samples);
            }

            s.close();
        }
        catch(IOException e)
        {
            GameObject.CrashLog("Error reading file: " + s_curvefilename + "\n");
            return;
        }
    }

    void DeleteCurve(int idx)
    {
        if(idx < 0 || idx > s_curves.size())
        {
            return;
        } else
        {
            s_curves.removeElementAt(idx);
            return;
        }
    }

    public static CurveManager GetInstance()
    {
        if(instance == null)
            instance = new CurveManager();
        return instance;
    }

    int GetCurveId(String name)
    {
        for(int i = 0; i < s_curves.size(); i++)
            if(((Curve)s_curves.get(i)).name.compareTo(name) == 0)
                return i;

        return -1;
    }

    void Rebuild()
    {
        for(int i = 0; i < s_curves.size(); i++)
        {
            Curve c = (Curve)s_curves.elementAt(i);
            c.Build(c.samples);
        }

    }

    protected Vector GetCurves()
    {
        return s_curves;
    }

    void Save()
    {
        DataOutputStream s = null;
        try
        {
            s = new DataOutputStream(new FileOutputStream(s_curvefilename));
        }
        catch(FileNotFoundException e)
        {
            GameObject.CrashLog("Curve definition file " + s_curvefilename + " not created\n");
            return;
        }
        try
        {
            for(int i = 0; i < s_curves.size(); i++)
            {
                Curve c = (Curve)s_curves.get(i);
                s.writeByte(c.GetType());
                s.writeUTF(c.name);
                s.writeShort(c.samples);
                s.writeFloat(c.minx);
                s.writeFloat(c.maxx);
                s.writeFloat(c.miny);
                s.writeFloat(c.maxy);
                c.Write(s);
                GameObject.LogLine("saved curve definition: " + c.name + "[" + c.toString() + "]");
            }

            s.close();
        }
        catch(IOException e)
        {
            GameObject.CrashLog("Error writing file: " + s_curvefilename + "\n");
            return;
        }
    }

    Curve GetCurve(String name)
    {
        Curve found = GetCurve(GetCurveId(name));
        if(found == null)
            GameObject.CrashLog("Can't find curve named <" + name + ">\n");
        return found;
    }

    protected static Vector s_curves = new Vector();
    protected static String s_curvefilename = "Data\\curve.dat";
    protected static CurveManager instance;

}
