// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Cursor.java


class Cursor extends Sprite
{

    void OnDestroy()
    {
        if(cursorTex != null)
        {
            if(module != null)
                module.RemoveSprite(cursorTex);
            cursorTex.ReleaseTexture(iTexNum);
            cursorTex = null;
        }
        if(toolTip != null)
        {
            if(module != null)
                module.RemoveSprite(toolTip);
            toolTip = null;
        }
        if(module != null)
            module.RemoveSprite(this);
    }

    Cursor()
    {
        cursorTex = null;
        iTexNum = 0;
        toolTip = null;
        sToolTipTex = null;
        fToolTipMargin = 2.0F;
        vCursorSize = new Vector();
        module = null;
    }

    public void SetPos(Vector vPos)
    {
        SetCursorPos(vPos);
        if(cursorTex != null)
            cursorTex.SetPos(vPos);
    }

    void Destroy()
    {
        if(module != null)
        {
            if(toolTip != null)
            {
                module.RemoveSprite(toolTip);
                toolTip.delete();
                toolTip = null;
            }
            if(cursorTex != null)
            {
                module.RemoveSprite(cursorTex);
                cursorTex.delete();
                cursorTex = null;
            }
        }
    }

    void InitToolTip(Module mod, String sTexName, Rect rTexPos, String sFontID, float fR, float fG, float fB, 
            float fA)
    {
        module = mod;
        if(toolTip == null)
        {
            toolTip = (Sprite)mod.CreateObject("Sprite");
            if(sTexName != null && sTexName.length() > 0)
            {
                iTexNum = cursorTex.AddTexture(sTexName, true, true);
                toolTip.SetTexture(iTexNum, rTexPos);
            }
            toolTip.SetSize(new Vector(0.0F, 0.0F, 0.0F));
            toolTip.SetPos(new Vector(0.0F, 0.0F, 0.0F));
            toolTip.ProcessMouse(false);
            cursorTex.AddChild(toolTip);
            toolTip.MoveTop();
        } else
        {
            iTexNum = cursorTex.AddTexture(sTexName, true, true);
            toolTip.SetTexture(iTexNum, rTexPos);
        }
        if(cursorTex != null)
            vCursorSize = cursorTex.GetSize();
        toolTip.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE | ESpriteText.VERT_MIDDLE);
        if(sFontID == null)
            toolTip.SetFont("MSSansSerif12");
        else
            toolTip.SetFont(sFontID);
        toolTip.SetTextColor(fR, fG, fB, fA);
    }

    void DisplayToolTip(String sText)
    {
        float fScreenWidth = 0.0F;
        float fScreenHeight = 0.0F;
        if(sText.length() > 0)
        {
            Vector vCursorPos = cursorTex.GetPos();
            Vector vToolTipPos = new Vector(vCursorPos.fX + vCursorSize.fX, vCursorPos.fY + vCursorSize.fY, 0.0F);
            fScreenWidth = GameObject.GetScreenWidth();
            fScreenHeight = GameObject.GetScreenHeight();
            Vector vTextSize = toolTip.GetTextExtent(sText);
            vTextSize.fX += 2.0F * fToolTipMargin;
            vTextSize.fY += 2.0F * fToolTipMargin;
            toolTip.SetSize(vTextSize);
            if(vToolTipPos.fY + vTextSize.fY > fScreenHeight)
                vToolTipPos.fY -= vCursorSize.fY;
            if(vToolTipPos.fX + vTextSize.fX > fScreenWidth)
                vToolTipPos.fX = fScreenWidth - vTextSize.fX;
            toolTip.SetPos(vToolTipPos);
            toolTip.DisplayText(sText);
            toolTip.Show();
        } else
        {
            toolTip.Hide();
        }
    }

    public void Hide()
    {
        cursorTex.Hide();
    }

    void SetCursorTex(Module mod, String textureName)
    {
        module = mod;
        cursorTex = (Sprite)mod.CreateObject("Sprite");
        iTexNum = cursorTex.AddTexture(textureName, true, true);
        cursorTex.SetTexture(iTexNum, new Rect(0.0F, 0.0F, 1.0F, 1.0F));
        cursorTex.SetSize(new Vector(32F, 32F, 0.0F));
        cursorTex.SetPos(new Vector(0.0F, 0.0F, 0.0F));
        cursorTex.ProcessMouse(false);
        cursorTex.Show();
        mod.AddSprite(cursorTex);
        cursorTex.MoveTop();
        vCursorSize = cursorTex.GetSize();
        ProcessMouse(true);
        SetPos(new Vector(0.0F, 0.0F, 0.0F));
        SetSize(new Vector(GameObject.GetScreenWidth(), GameObject.GetScreenHeight(), 0.0F));
        mod.AddSprite(this);
    }

    public void MoveTop()
    {
        super.MoveTop();
        if(toolTip != null)
            toolTip.MoveTop();
        if(cursorTex != null)
            cursorTex.MoveTop();
    }

    public void Show()
    {
        cursorTex.Show();
    }

    void OnCreate()
    {
        ProcessCapturedMouseMove(true);
    }

    void SetToolTipTextColor(float fR, float fG, float fB)
    {
        if(toolTip != null)
            toolTip.SetTextColor(fR, fG, fB, 1.0F);
        else
            GameObject.CrashLog("Cursor.SetToolTipTextColor : musisz najpierw utworzyc sprite tooltipa!!!");
    }

    Vector GetPointerPos()
    {
        if(cursorTex != null)
            return cursorTex.GetPos();
        else
            return null;
    }

    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
    {
        cursorTex.SetPos(new Vector(fMouseX, fMouseY, 0.0F));
    }

    void OnChangeResolution()
    {
        SetSize(new Vector(GameObject.GetScreenWidth(), GameObject.GetScreenHeight(), 0.0F));
    }

    Sprite cursorTex;
    int iTexNum;
    Sprite toolTip;
    String sToolTipTex;
    float fToolTipMargin;
    Vector vCursorSize;
    Module module;
}
