// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SGController.java

import java.io.*;
import java.util.*;
import java.util.zip.*;

public class SGController
{

    SGObject GetObjectByID(int nID)
    {
        if(vObjects != null)
        {
            for(int i = 0; i < vObjects.size(); i++)
            {
                SGObject cSGObj = (SGObject)vObjects.elementAt(i);
                if(cSGObj.nID == nID)
                    return cSGObj;
            }

        }
        return null;
    }

    public int IsValidSaveVersion(String sFileName, long nValidNumber)
    {
        GameObject.CrashLog("---------------------------- \n");
        GameObject.CrashLog("[SGController.IsValidSaveVersion] : <" + sFileName + ">\n");
        GameObject.CrashLog("---------------------------- \n");
        File check = new File(sFileName);
        if(check.length() == 0L)
            return _DECOMPRESSION_FAILED;
        if(!DecompressFile(sFileName))
            return _DECOMPRESSION_FAILED;
        FileChunk cFCMain = GameObject.OpenFile(sFileName + ".temp");
        FileChunk cFCVersion = GameObject.LoadChunk(cFCMain);
        long nReadNumber = cFCVersion.LoadLong();
        File file;
        if(nReadNumber != nValidNumber)
        {
            cFCMain.delete();
            file = new File(sFileName + ".temp");
            if(!file.delete())
                GameObject.CrashLog("TempFile was not removed\n");
            return _WRONG_SAVE_VERSION_NUMBER;
        }
        cFCVersion.delete();
        FileChunk.Log("[SGController.SGController.IsValidSaveVersion] Skipping chunk <" + cFCMain.GetID() + ">!\n");
        cFCMain.delete();
        file = new File(sFileName + ".temp");
        if(!file.delete())
            GameObject.CrashLog("TempFile was not removed\n");
        return _SAVE_OK;
    }

    void DeactivateObject(GameObject obj)
    {
        if(obj == null)
            return;
        if(obj.IsCreatedDuringLoading())
        {
            GameObject.CrashLog("[SGController.LoadObjectRef] SG-ERROR! Object was not deleted !!! Name = <" + obj.GetName() + "> ID = <" + obj.GetUniqueID() + "> \n");
            return;
        }
        if(obj instanceof Sprite)
            ((Sprite)obj).RemoveSprite((Sprite)obj);
        obj.DisableCallMethods();
        if(obj instanceof ControlObject)
        {
            if(((ControlObject)obj).GetParent() != null)
                ((ControlObject)obj).DetachFromParent();
            ((ControlObject)obj).DetachAllSounds();
        }
        obj.DeactivateOnModuleAlways();
        if(obj instanceof MeshObject)
            ((MeshObject)obj).EnableRendering(false);
        obj.delete();
    }

    ISaveGame LoadSimpleObjectRef(FileChunk cFC)
    {
        int nObjectID = cFC.LoadInt();
        if(nObjectID == -1)
        {
            FileChunk.Log("[SGController.LoadSimpleObjectRef*] = null\n");
            return null;
        }
        FileChunk.Log("[SGController.LoadSimpleObjectRef*] UniqueID = <" + nObjectID + ">   \n");
        ISaveGame object = SGObjectsRepository.GetObject(nObjectID);
        if(object == null)
            GameObject.CrashLog("[SGController.LoadSimpleObjectRef*] SG-ERROR!: object is null\n");
        else
            FileChunk.Log("[SGController.LoadSimpleObjectRef*] UniqueID = <" + nObjectID + "> ClassName = <" + object.getClass().getName() + ">\n");
        return object;
    }

    Vector LoadObjectsVectorRef(FileChunk cFC)
    {
        int nSize = cFC.LoadInt();
        if(nSize == -1)
            return null;
        FileChunk.Log("[SGController.LoadObjectsVectorRef] Size = <" + nSize + ">\n");
        Vector vRefs = new Vector();
        vRefs.setSize(nSize);
        FileChunk.Log("[SGController.LoadObjectsVectorRef] Size = <" + vRefs.size() + ">\n");
        for(int i = 0; i < nSize; i++)
            vRefs.setElementAt(LoadObjectRef(cFC), i);

        return vRefs;
    }

    private SGController()
    {
        nReadVersion = -1L;
        nNextIDValue = -1;
        cMainFC = null;
        cPreObject = null;
        cModule = null;
        vObjects = null;
        bPreLoad = false;
        GameObject.cSG = this;
        FileChunk.cSG = this;
    }

    public int PreLoad(String sFileName, SGPreObject cPreObject)
    {
        if(nState != _SG_NONE)
        {
            GameObject.CrashLog("[SGController.PreLoad] SG-ERROR! State of SGController is different from expected !\n");
            Thread.dumpStack();
            return _PRELOAD_FAILED;
        }
        GameObject.CrashLog("---------------------------- \n");
        GameObject.CrashLog("[SGController.PreLoad] : <" + sFileName + ">\n");
        GameObject.CrashLog("---------------------------- \n");
        nState = _SG_PRE_LOAD;
        FileChunk.Log("[SGController.PreLoad] State! = <loading> \n");
        m_fStartTime = GameObject.GetAbsoluteTime();
        if(!DecompressFile(sFileName))
        {
            return _DECOMPRESSION_FAILED;
        } else
        {
            bPreLoad = true;
            this.cPreObject = cPreObject;
            PreLoadChunks(sFileName + ".temp");
            FileChunk.Log("[SGController.PreLoad] State! = <none> \n");
            bPreLoad = false;
            nState = _SG_PRE_LOAD_FINISHED;
            return _SAVE_OK;
        }
    }

    void CriticalError(String sErrorText)
    {
        GameObject.CrashLog("[SGController.CriticalError] " + sErrorText + "\n");
        Thread.currentThread();
        Thread.dumpStack();
        GameObject.SetPreCreateMode(false);
        nState = _SG_NONE;
    }

    public void Load(String sFileName, Module cModule)
    {
        if(nState != _SG_PRE_LOAD_FINISHED)
        {
            GameObject.CrashLog("[SGController.Load] SG-ERROR! State of SGController is different from expected !\n");
            Thread.dumpStack();
            return;
        }
        DumpDangerousObjects(cModule);
        GameObject.CrashLog("---------------------------- \n");
        GameObject.CrashLog("[SGController.Load] : <" + sFileName + ">\n");
        GameObject.CrashLog("---------------------------- \n");
        nState = _SG_LOAD;
        FileChunk.Log("[SGController.Load] State! = <loading> \n");
        this.cModule = cModule;
        GameObject aObjs[] = GameObject.GetObjectsFromClassModule("GameObject", cModule);
        FileChunk.Log("SG-INFO Number of gameobjects on module = <" + aObjs.length + "> \n");
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i] instanceof ControlObject)
                ((ControlObject)aObjs[i]).UnregisterInInteractionMap();

        PreLoadChunks(sFileName + ".temp");
        aObjs = GameObject.GetObjectsFromClassModule("GameObject", cModule);
        LoadChunks(sFileName + ".temp");
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i].bSG && !aObjs[i].bSGLoaded && !aObjs[i].IsCreatedDuringLoading())
            {
                FileChunk.Log("[SGController.Load] Removing object ID = <" + aObjs[i].GetUniqueID() + "> ClassName = <" + aObjs[i].getClass().getName() + "> Name = <" + aObjs[i].GetName() + ">\n");
                aObjs[i].SetUniqueID();
                DeactivateObject(aObjs[i]);
            } else
            {
                aObjs[i].bSGLoaded = false;
            }

        FileChunk.Log("[SGController.Load] : Objects updating\n");
        SGObjectsRepository.SGUpdate();
        for(int i = 0; i < vObjects.size(); i++)
        {
            GameObject obj = ((SGObject)vObjects.elementAt(i)).cObj;
            if(obj != null)
                obj.bLoadingSG = true;
        }

        this.cModule.bLoadingSG = true;
        for(int i = 0; i < vObjects.size(); i++)
        {
            GameObject obj = ((SGObject)vObjects.elementAt(i)).cObj;
            if(obj != null)
                obj.SGUpdate();
        }

        this.cModule.SGUpdate();
        for(int i = 0; i < vObjects.size(); i++)
        {
            GameObject obj = ((SGObject)vObjects.elementAt(i)).cObj;
            if(obj != null)
                obj.bLoadingSG = false;
        }

        this.cModule.bLoadingSG = false;
        for(int i = 0; i < vObjects.size(); i++)
        {
            SGObject cSGObj = (SGObject)vObjects.elementAt(i);
            if(cSGObj != null && cSGObj.cObj != null)
                if(cSGObj.bActiveOnModule && !cSGObj.cObj.IsActiveOnModule())
                {
                    cSGObj.cObj.DeactivateOnModuleAlways();
                    if(cSGObj.bGridIndependent)
                        ((ControlObject)cSGObj.cObj).ActivateOnModuleGridIndependent();
                    else
                        cSGObj.cObj.ActivateOnModule();
                    FileChunk.Log("[SGController.LoadObjectRef] SG-WARNING! Object <" + cSGObj.cObj.GetName() + ":" + cSGObj.cObj.getClass().getName() + "> was not activated !\n");
                } else
                if(!cSGObj.bActiveOnModule && cSGObj.cObj.IsActiveOnModule())
                {
                    cSGObj.cObj.DeactivateOnModuleAlways();
                    FileChunk.Log("[SGController.LoadObjectRef] SG-WARNING! Object <" + cSGObj.cObj.GetName() + ":" + cSGObj.cObj.getClass().getName() + "> was not deactivated !\n");
                }
        }

        this.cModule = null;
        cPreObject = null;
        nState = _SG_NONE;
        FileChunk.Log("[SGController.Load] State! = <none> \n");
        File file = new File(sFileName + ".temp");
        if(!file.delete())
            GameObject.CrashLog("TempFile was not removed\n");
        if(!sFileName.equals(_SG_RESTARTSAVELOAD_FILE))
        {
            CopyFile(sFileName + ".dat", _SG_RESTARTSAVELOAD_FILE);
            CopyFile(sFileName + ".lev", _SG_RESTARTSAVELOAD_FILE + ".lev");
        }
        DumpDangerousObjects(cModule);
        aObjs = null;
        m_fEndTime = GameObject.GetAbsoluteTime();
    }

    boolean IsLoading()
    {
        return nState == _SG_LOAD;
    }

    boolean IsSaving()
    {
        return nState == _SG_SAVE;
    }

    private boolean DecompressFile(String sFileName)
    {
        int nRead = 0;
        boolean bRet = true;
        try
        {
            FileOutputStream jTempOut = new FileOutputStream(sFileName + ".temp");
            FileInputStream jSave = new FileInputStream(sFileName);
            ZipInputStream jSaveZip = new ZipInputStream(jSave);
            ZipEntry jEntry = jSaveZip.getNextEntry();
            while((nRead = jSaveZip.read(buffer, 0, _SG_BUFFER_SIZE)) != -1) 
                jTempOut.write(buffer, 0, nRead);
            jSaveZip.closeEntry();
            jSaveZip.close();
            jSave.close();
            jTempOut.close();
        }
        catch(IOException e)
        {
            GameObject.CrashLog("SG-ERROR! File <" + sFileName + "> was not decompressed !\n");
            bRet = false;
        }
        return bRet;
    }

    private void PreLoadChunks(String sFileName)
    {
        FileChunk cMain = GameObject.OpenFile(sFileName);
        FileChunk.Log("[SGController.PreLoadChunks] <<< PRELOAD - BEGIN >>>\n");
        FileChunk.Log("[SGController.PreLoadChunks] MainChunk data to read <" + cMain.GetDataToRead() + ">\n");
        FileChunk cFC;
        for(; cMain.GetDataToRead() != 0; cFC.delete())
        {
            FileChunk.Log("---------------------------- \n");
            cFC = GameObject.LoadChunk(cMain);
            FileChunk.Log("[SGController.PreLoadChunks] Chunk <" + cFC.GetID() + "> data in chunk <" + cFC.GetDataToRead() + ">\n");
            switch(cFC.GetID())
            {
            case 106: // 'j'
                break;

            case 136: 
                nReadVersion = cFC.LoadLong();
                break;

            case 151: 
                nNextIDValue = cFC.LoadInt();
                if(cModule.GetNextIDValue() < nNextIDValue)
                    cModule.SetNextIDValue(nNextIDValue);
                break;

            case 101: // 'e'
                LoadObjectsTable(cFC);
                break;

            case 102: // 'f'
                if(bPreLoad)
                {
                    cPreObject.PreLoad(cFC, cModule);
                    FileChunk.Log("[SGController.PreLoadChunks] Skipping chunk <" + cFC.GetID() + ">!\n");
                    cMain.delete();
                    return;
                }
                FileChunk.Log("[SGController.PreLoadChunks] Skipping chunk <" + cFC.GetID() + ">!\n");
                break;

            case 104: // 'h'
                SGObjectsRepository.SGLoadChunk(cFC);
                break;

            case 105: // 'i'
                cModule.LoadExpressionVarMan(cFC);
                break;

            case 103: // 'g'
                FileChunk.Log("[SGController.PreLoadChunks] Skipping chunk <" + cFC.GetID() + ">!\n");
                break;

            default:
                GameObject.CrashLog("[SGController.PreLoadChunks] Unrecognized chunk <" + cFC.GetID() + ">!\n");
                break;
            }
        }

        cMain.delete();
        FileChunk.Log("[SGController.PreLoadChunks] <<< PRELOAD - END >>>\n");
    }

    private void LoadChunks(String sFileName)
    {
        FileChunk cMain = GameObject.OpenFile(sFileName);
        FileChunk.Log("----------------------------------------------------------------------- \n");
        FileChunk.Log("[SGController.LoadChunks]\t\t\t\tONLY OBJECTS\t\t\t\t\t \n");
        FileChunk.Log("[SGController.LoadChunks] MainChunk data to read <" + cMain.GetDataToRead() + ">\n");
        FileChunk.Log("----------------------------------------------------------------------- \n");
        FileChunk cFC;
        for(; cMain.GetDataToRead() != 0; cFC.delete())
        {
            FileChunk.Log("---------------------------- \n");
            cFC = GameObject.LoadChunk(cMain);
            FileChunk.Log("[SGController.LoadChunks] Chunk <" + cFC.GetID() + "> data in chunk <" + cFC.GetDataToRead() + ">\n");
            switch(cFC.GetID())
            {
            case 101: // 'e'
            case 102: // 'f'
            case 104: // 'h'
            case 105: // 'i'
            case 136: 
                FileChunk.Log("[SGController.LoadChunks] Skipping chunk <" + cFC.GetID() + ">!\n");
                break;

            case 103: // 'g'
                LoadObject(cFC);
                break;

            default:
                FileChunk.Log("[SGController.LoadChunks] Unrecognized chunk <" + cFC.GetID() + ">!\n");
                break;
            }
        }

        cMain.delete();
        FileChunk.Log("----------------------------------------------------------------------- \n");
        FileChunk.Log("[SGController.LoadChunks]\t\t\t\tONLY OBJECTS - END\t\t\t\t \n");
        FileChunk.Log("----------------------------------------------------------------------- \n");
    }

    private boolean CompressFile(String sFileName)
    {
        int nRead = 0;
        boolean bRet = true;
        File fFile = new File(sFileName + ".temp");
        if(!fFile.exists())
            return false;
        if(fFile.length() == 0L)
        {
            fFile.delete();
            return false;
        }
        fFile = null;
        try
        {
            FileInputStream jTempIn = new FileInputStream(sFileName + ".temp");
            FileOutputStream jSave = new FileOutputStream(sFileName, false);
            ZipOutputStream jSaveZip = new ZipOutputStream(jSave);
            jSaveZip.setLevel(9);
            ZipEntry jEntry = new ZipEntry("data");
            jEntry.setMethod(8);
            jSaveZip.putNextEntry(jEntry);
            while((nRead = jTempIn.read(buffer, 0, _SG_BUFFER_SIZE)) != -1) 
                jSaveZip.write(buffer, 0, nRead);
            jSaveZip.closeEntry();
            jSaveZip.close();
            jSave.close();
            jTempIn.close();
            File file = new File(sFileName + ".temp");
            file.delete();
        }
        catch(IOException e)
        {
            GameObject.CrashLog("SG-ERROR! File <" + sFileName + "> was not compressed !\n");
            bRet = false;
        }
        fFile = new File(sFileName);
        if(fFile.exists() && fFile.length() == 0L)
        {
            fFile.delete();
            return false;
        } else
        {
            fFile = null;
            return bRet;
        }
    }

    public void SaveGameObjects(boolean bReset)
    {
        SaveObjectsTable(false, bReset);
        int nSize = -1;
        for(int nTurn = 0; nSize != vObjects.size(); nTurn++)
        {
            FileChunk.Log(" BEGIN TURN = <" + nTurn + "> \n");
            nSize = vObjects.size();
            for(int i = 0; i < vObjects.size(); i++)
                SaveObjectAfterParents(((SGObject)vObjects.elementAt(i)).cObj);

            SaveObjectsTable(false, false);
            FileChunk.Log(" END TURN = <" + nTurn + "> \n");
        }

    }

    GameObject LoadObject(FileChunk cFCObj)
    {
        FileChunk.Log("[SGController.LoadObject]\n");
        GameObject obj = LoadGameObjectRef(cFCObj);
        if(obj == null)
            return null;
        if(!obj.IsCreatedFromEngine())
            GameObject.CrashLog("[SGController.LoadObject] SG-ERROR! Object was not created from engine!!!\n");
        obj.bLoadingSG = true;
        if(cFCObj.GetDataToRead() != 0)
        {
            FileChunk.Log("cFCObj.GetDataToRead()=" + cFCObj.GetDataToRead() + "\n");
            obj.SGLoadChunk(cFCObj);
        }
        if(cFCObj.GetDataToRead() != 0)
            GameObject.CrashLog("[SGController.LoadObject] ERROR !!! Data was not read : <" + cFCObj.GetDataToRead() + ">\n");
        obj.bLoadingSG = false;
        return obj;
    }

    void SaveObjectRef(FileChunk cFC, ISaveGame obj)
    {
        boolean bSaveType = false;
        if(obj instanceof GameObject)
        {
            bSaveType = true;
            if(((GameObject)obj).GetUniqueID() == -1)
                bSaveType = false;
        }
        if(bSaveType)
            cFC.SaveBool(true);
        else
            cFC.SaveBool(false);
        if(obj == null)
        {
            cFC.SaveInt(-1);
            FileChunk.Log("[SGController.SaveObjectRef] = null\n");
        } else
        if(bSaveType)
        {
            if(!((GameObject)obj).bSG)
                if(!((GameObject)obj).IsCreatedDuringLoading())
                {
                    ((GameObject)obj).bSG = true;
                    FileChunk.Log("[SGController.SaveObjectRef] SG-INFO! Mark <bSG> changed from 'false' to 'true' ! UniqueID = <" + ((GameObject)obj).GetUniqueID() + "> ClassName = <" + obj.getClass().getName() + ">\n");
                } else
                {
                    FileChunk.Log("[SGController.SaveObjectRef] SG-WARNING! Object created in editor! Failed trying mark <bSG> for UniqueID = <" + ((GameObject)obj).GetUniqueID() + "> ClassName = <" + obj.getClass().getName() + ">\n");
                }
            cFC.SaveInt(((GameObject)obj).GetUniqueID());
            cFC.SaveString(obj.getClass().getName());
            FileChunk.Log("[SGController.SaveObjectRef] UniqueID = <" + ((GameObject)obj).GetUniqueID() + "> ClassName = <" + obj.getClass().getName() + ">\n");
        } else
        {
            int nCode = SGObjectsRepository.AddObject(obj);
            cFC.SaveInt(nCode);
            FileChunk.Log("[SGController.SaveObjectRef*] UniqueID = <" + nCode + "> ClassName = <" + obj.getClass().getName() + ">\n");
        }
    }

    ISaveGame LoadObjectRef(FileChunk cFC)
    {
        if(cFC.LoadBool())
            return LoadGameObjectRef(cFC);
        else
            return LoadSimpleObjectRef(cFC);
    }

    void CopyFile(String sFileSrc, String sFileDst)
    {
        try
        {
            File fFileDst = new File(sFileDst);
            if(!fFileDst.exists() && !fFileDst.createNewFile())
            {
                GameObject.CrashLog("[SGController.CopyFile] SG-ERROR! DstFile <" + sFileDst + "> was not created ! \n");
                return;
            }
            File fFileSrc = new File(sFileSrc);
            if(!fFileSrc.exists())
            {
                GameObject.CrashLog("[SGController.CopyFile] SG-ERROR! SrcFile <" + sFileSrc + "> doesn't exist ! \n");
                return;
            }
            DataInputStream cRestartIn = new DataInputStream(new FileInputStream(sFileSrc));
            DataOutputStream cRestartOut = new DataOutputStream(new FileOutputStream(sFileDst));
            byte tBuffer[] = new byte[1024];
            do
            {
                int nRead = cRestartIn.read(tBuffer);
                if(nRead <= 0)
                    break;
                cRestartOut.write(tBuffer, 0, nRead);
            } while(true);
            cRestartIn.close();
            cRestartOut.close();
        }
        catch(Exception e)
        {
            GameObject.CrashLog("[SGController.CopyFile] SG-ERROR! File <" + sFileSrc + "> was not copied to <" + sFileDst + "> ! \n");
        }
    }

    void SaveObjectsTable(boolean bWriteTable, boolean bResetObjects)
    {
        FileChunk.Log("[SGController.SaveObjectsTable]\n");
        GameObject aObjs[] = GameObject.GetObjectsFromClassModule("GameObject", cModule);
        FileChunk.Log("SG-INFO Number of GameObjects on module = <" + aObjs.length + "> \n");
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i].bSG && (aObjs[i] instanceof ControlObject))
            {
                ControlObject aChildren[] = ((ControlObject)aObjs[i]).GetChildren();
                if(aChildren != null)
                {
                    for(int j = 0; j < aChildren.length; j++)
                        aChildren[j].bSG = true;

                }
            }

        int nSGObjects = 0;
        for(int i = 0; i < aObjs.length; i++)
        {
            if(bResetObjects)
                aObjs[i].bSGRepeated = false;
            if(aObjs[i].bSG)
                nSGObjects++;
        }

        FileChunk cFC = null;
        if(bWriteTable)
        {
            cFC = GameObject.NewChunk(101, cMainFC);
            cFC.SaveInt(nSGObjects);
        }
        vObjects = new Vector(nSGObjects);
        List listObjs = Arrays.asList(aObjs);
        Collections.sort(listObjs);
        aObjs = (GameObject[])listObjs.toArray();
        if(bResetObjects)
        {
            GameObject.CrashLog("<<< ERRORS SECTION - BEGIN >>>\n");
            for(int i = 0; i < aObjs.length; i++)
            {
                for(int j = i + 1; j < aObjs.length; j++)
                {
                    if(aObjs[i].GetUniqueID() != aObjs[j].GetUniqueID())
                        break;
                    GameObject.CrashLog("[Object-1] UniqueID = <" + aObjs[i].GetUniqueID() + "> ClassName = <" + aObjs[i].getClass().getName() + "> Name <" + aObjs[i].GetName() + "> ThisID <" + aObjs[i].GetThisID() + ">\n");
                    GameObject.CrashLog("[Object-2] UniqueID = <" + aObjs[j].GetUniqueID() + "> ClassName = <" + aObjs[j].getClass().getName() + "> Name <" + aObjs[j].GetName() + "> ThisID <" + aObjs[j].GetThisID() + ">\n");
                }

            }

            GameObject.CrashLog("<<< ERRORS SECTION - END >>>\n");
        }
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i].bSG)
            {
                SGObject cSGObj = new SGObject(aObjs[i]);
                vObjects.addElement(cSGObj);
                if(bWriteTable)
                {
                    cFC.SaveInt(cSGObj.nID);
                    cFC.SaveString(cSGObj.sClassName);
                    cFC.SaveBool(cSGObj.bActiveOnModule);
                    cFC.SaveBool(cSGObj.bGridIndependent);
                    FileChunk.Log("[Object] UniqueID = <" + cSGObj.nID + "> ClassName = <" + cSGObj.sClassName + ">\n");
                }
            }

        if(bWriteTable)
            cFC.delete();
        FileChunk.Log("---------------------------- \n");
    }

    public void SaveObjectAfterParents(GameObject obj)
    {
        if(obj.bSGRepeated)
            return;
        if(obj instanceof ControlObject)
        {
            ControlObject parent = ((ControlObject)obj).GetParent();
            if(parent != null)
            {
                parent.bSG = true;
                SaveObjectAfterParents(((GameObject) (parent)));
            }
        }
        FileChunk.Log("[Object] UniqueID = <" + obj.GetUniqueID() + "> ClassName = <" + obj.getClass().getName() + ">\n");
        FileChunk cFC = GameObject.NewChunk(103, cMainFC);
        cFC.SaveInt((obj instanceof Module) ? 0 : obj.GetUniqueID());
        cFC.SaveString(obj.getClass().getName());
        obj.SGSaveChunk(cFC);
        cFC.delete();
        FileChunk.Log("---------------------------- \n");
    }

    void DumpDangerousObjects(Module module)
    {
    }

    void RemoveObjectsOverNextID(Module mod)
    {
        GameObject aObjs[] = GameObject.GetObjectsFromClassModule("GameObject", cModule);
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i].GetUniqueID() > nNextIDValue)
                DeactivateObject(aObjs[i]);

    }

    GameObject LoadGameObjectRef(FileChunk cFCObj)
    {
        int nID = cFCObj.LoadInt();
        if(nID == -1)
        {
            FileChunk.Log("[SGController.LoadGameObjectRef] Reference is <null>\n");
            return null;
        }
        String sClassName = cFCObj.LoadString();
        FileChunk.Log("[SGController.LoadGameObjectRef] UniqueID = <" + nID + "> ClassName = <" + sClassName + "> LoadGameObjectRef\n");
        if(nID == 0)
        {
            FileChunk.Log("[SGController.LoadGameObjectRef] Module : " + sClassName + " loaded\n");
            return cModule;
        }
        SGObject cSGObj = GetObjectByID(nID);
        if(cSGObj == null)
        {
            GameObject cObj = cModule.GetObjectByID(nID);
            if(cObj != null)
            {
                if(cObj.getClass().getName().compareTo(sClassName) != 0)
                {
                    FileChunk.Log("[SGController.LoadObjectRef] Object (+) <" + cObj.getClass().getName() + "> deleted and created new <" + sClassName + ">\n");
                    cObj.SetUniqueID();
                    if(!cObj.bSG)
                        DeactivateObject(cObj);
                    cObj = cModule.CreateObjectNoInit(sClassName, nID);
                    cObj.InitObject();
                }
                return cObj;
            } else
            {
                GameObject.CrashLog("[SGController.LoadObjectRef] nID=" + nID + " sClassName=" + sClassName + "\n");
                GameObject.CrashLog("[SGController.LoadObjectRef] SG-ERROR! This will never happen!\n");
                CriticalError("Error file reading !");
                return null;
            }
        }
        if(cSGObj.cObj == null)
        {
            cSGObj.cObj = cModule.GetObjectByID(nID);
            if(cSGObj.cObj == null)
            {
                FileChunk.Log("[SGController.LoadObjectRef] Object was not found sClassName=<" + sClassName + "> nID=" + nID + "\n");
                cSGObj.cObj = cModule.CreateObjectNoInit(sClassName, nID);
                cSGObj.cObj.InitObject();
            } else
            if(cSGObj.cObj.getClass().getName().compareTo(sClassName) != 0)
            {
                if(cSGObj.cObj.IsCreatedDuringLoading())
                    GameObject.CrashLog("[SGController.LoadObjectRef] SG-ERROR!!! That is impossible! Object to move was created in editor and can not be renumerted or deleted.  \n");
                else
                if(!cSGObj.cObj.bSG)
                {
                    cSGObj.cObj.SetUniqueID();
                    FileChunk.Log("[SGController.LoadObjectRef] Object (++) <" + cSGObj.cObj.GetName() + ":" + cSGObj.cObj.getClass().getName() + "> renumerated becouse of <" + sClassName + ">\n");
                    cSGObj.cObj = cModule.CreateObjectNoInit(sClassName, nID);
                    cSGObj.cObj.InitObject();
                } else
                {
                    FileChunk.Log("[SGController.LoadObjectRef] Object (++) <" + cSGObj.cObj.GetName() + ":" + cSGObj.cObj.getClass().getName() + "> deleted and created new <" + sClassName + ">\n");
                    cSGObj.cObj.SetUniqueID();
                    if(!cSGObj.cObj.bSG)
                        DeactivateObject(cSGObj.cObj);
                    cSGObj.cObj = cModule.CreateObjectNoInit(sClassName, nID);
                    cSGObj.cObj.InitObject();
                }
            } else
            {
                FileChunk.Log("[SGController.LoadObject] Object loaded with module.\n");
            }
        }
        if(sClassName.compareTo(cSGObj.cObj.getClass().getName()) != 0)
            GameObject.CrashLog("[SGController.LoadObject] SG-ERROR! Wrong class! Expected <" + sClassName + "> but <" + cSGObj.cObj.getClass().getName() + "> !.\n");
        if(cSGObj.cObj != null)
            cSGObj.cObj.bSGLoaded = true;
        return cSGObj.cObj;
    }

    void SaveObjectsVectorRef(FileChunk cFC, Vector vRefs)
    {
        if(vRefs == null)
        {
            cFC.SaveInt(-1);
            return;
        }
        int nSize = vRefs.size();
        FileChunk.Log("[SGController.SaveObjectsVectorRef] Size = <" + nSize + ">\n");
        cFC.SaveInt(nSize);
        for(int i = 0; i < nSize; i++)
            SaveObjectRef(cFC, (ISaveGame)vRefs.elementAt(i));

    }

    void LoadObjectsTable(FileChunk cFC)
    {
        FileChunk.Log("[SGController.LoadObjectsTable]\n");
        int nSGObjects = cFC.LoadInt();
        vObjects = new Vector(nSGObjects);
        FileChunk.Log("<Number of objects> = " + nSGObjects + "\n+");
        for(int i = 0; i < nSGObjects; i++)
        {
            SGObject cSGObj = new SGObject(cFC.LoadInt(), cFC.LoadString(), cFC.LoadBool(), cFC.LoadBool());
            vObjects.addElement(cSGObj);
            FileChunk.Log("[Object] UniqueID = <" + cSGObj.nID + "> ClassName = <" + cSGObj.sClassName + ">\n");
        }

    }

    public void Save(String sFileName, Module cModule, SGPreObject cPreObject)
    {
        if(nState != _SG_NONE)
        {
            GameObject.CrashLog("[SGController.Save] SG-ERROR! State of SGController is different from expected !\n");
            Thread.dumpStack();
            return;
        }
        m_fStartTime = GameObject.GetAbsoluteTime();
        GameObject.CrashLog("---------------------------- \n");
        GameObject.CrashLog("[SGController.Save] : <" + sFileName + "> Version = <" + cModule.GetSaveVersion() + "> \n");
        GameObject.CrashLog("---------------------------- \n");
        DumpDangerousObjects(cModule);
        SGObjectsRepository.Reset();
        nState = _SG_SAVE;
        FileChunk.Log("[SGController.Save] State! = <saving> \n");
        this.cModule = cModule;
        this.cPreObject = cPreObject;
        cMainFC = GameObject.NewFile(sFileName + ".temp");
        FileChunk cFCVersion = GameObject.NewChunk(136, cMainFC);
        cFCVersion.SaveLong(cModule.GetSaveVersion());
        cFCVersion.delete();
        if(cPreObject != null)
        {
            FileChunk cFCPreSave = GameObject.NewChunk(102, cMainFC);
            FileChunk.Log("[SGController.Save] : Special information about save \n");
            cPreObject.PreSave(cFCPreSave);
            cFCPreSave.delete();
        } else
        {
            GameObject.CrashLog("[SGController.Save] SG-ERROR ! pre-object = null \n");
        }
        FileChunk cFCAddIns = GameObject.NewChunk(151, cMainFC);
        cFCAddIns.SaveInt(cModule.GetNextIDValue());
        cFCAddIns.delete();
        FileChunk cFCSave = GameObject.NewChunk(105, cMainFC);
        cModule.SaveExpressionVarMan(cFCSave);
        cFCSave.delete();
        SaveGameObjects(true);
        SGObjectsRepository.SGSaveChunk(cMainFC, true);
        SaveGameObjects(false);
        SaveObjectsTable(true, false);
        SGObjectsRepository.SGSaveChunk(cMainFC, false);
        cMainFC.delete();
        this.cModule = null;
        this.cPreObject = cPreObject;
        CompressFile(sFileName);
        nState = _SG_NONE;
        FileChunk.Log("[SGController.Save] State! = <none> \n");
        if(!sFileName.equals(_SG_RESTARTSAVELOAD_FILE))
            CopyFile(_SG_RESTARTSAVELOAD_FILE, sFileName + ".dat");
        DumpDangerousObjects(cModule);
        m_fEndTime = GameObject.GetAbsoluteTime();
    }

    public static SGController inst = new SGController();
    public static int _SAVE_OK = 0;
    public static int _WRONG_SAVE_VERSION_NUMBER = 1;
    public static int _DECOMPRESSION_FAILED = 2;
    public static int _WRONG_CRC32_FOR_MAP_FILE = 3;
    public static int _PRELOAD_FAILED = 4;
    private static int _SG_BUFFER_SIZE;
    static String _SG_RESTARTSAVELOAD_FILE = "save/restart.sav";
    private static byte buffer[];
    static int _SG_NONE;
    static int _SG_PRE_LOAD = 1;
    static int _SG_PRE_LOAD_FINISHED = 2;
    static int _SG_LOAD = 3;
    static int _SG_SAVE = 4;
    static float m_fStartTime = 0.0F;
    static float m_fEndTime = 0.0F;
    static int nState;
    long nReadVersion;
    int nNextIDValue;
    FileChunk cMainFC;
    SGPreObject cPreObject;
    Module cModule;
    Vector vObjects;
    boolean bPreLoad;

    static 
    {
        _SG_BUFFER_SIZE = 65000;
        buffer = new byte[_SG_BUFFER_SIZE];
        _SG_NONE = 0;
        nState = _SG_NONE;
    }
}
